<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpecialRemarkType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfSpecialRemarkType extends AbstractStructArrayBase
{
    /**
     * The Remark
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgSpecialRemarkType[]
     */
    public $Remark;
    /**
     * Constructor method for ArrayOfSpecialRemarkType
     * @uses DgArrayOfSpecialRemarkType::setRemark()
     * @param \dgsoft\StructType\DgSpecialRemarkType[] $remark
     */
    public function __construct(array $remark = array())
    {
        $this
            ->setRemark($remark);
    }
    /**
     * Get Remark value
     * @return \dgsoft\StructType\DgSpecialRemarkType[]|null
     */
    public function getRemark()
    {
        return $this->Remark;
    }
    /**
     * Set Remark value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgSpecialRemarkType[] $remark
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkType
     */
    public function setRemark(array $remark = array())
    {
        foreach ($remark as $arrayOfSpecialRemarkTypeRemarkItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpecialRemarkTypeRemarkItem instanceof \dgsoft\StructType\DgSpecialRemarkType) {
                throw new \InvalidArgumentException(sprintf('The Remark property can only contain items of \dgsoft\StructType\DgSpecialRemarkType, "%s" given', is_object($arrayOfSpecialRemarkTypeRemarkItem) ? get_class($arrayOfSpecialRemarkTypeRemarkItem) : gettype($arrayOfSpecialRemarkTypeRemarkItem)), __LINE__);
            }
        }
        $this->Remark = $remark;
        return $this;
    }
    /**
     * Add item to Remark value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgSpecialRemarkType $item
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkType
     */
    public function addToRemark(\dgsoft\StructType\DgSpecialRemarkType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgSpecialRemarkType) {
            throw new \InvalidArgumentException(sprintf('The Remark property can only contain items of \dgsoft\StructType\DgSpecialRemarkType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Remark[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgSpecialRemarkType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgSpecialRemarkType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgSpecialRemarkType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgSpecialRemarkType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgSpecialRemarkType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Remark
     */
    public function getAttributeName()
    {
        return 'Remark';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfSpecialRemarkType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
